TrcPktDecodeEtmV3 Class Reference

`#include <trc_pkt_decode_etmv3.h>`

Inheritance diagram for TrcPktDecodeEtmV3:
[legend]
Collaboration diagram for TrcPktDecodeEtmV3:
[legend]

## Public Member Functions

| TrcPktDecodeEtmV3 ()
| TrcPktDecodeEtmV3 (int instIDNum)
virtual | ~TrcPktDecodeEtmV3 ()
Public Member Functions inherited from TrcPktDecodeBase< EtmV3TrcPacket, EtmV3Config >
| TrcPktDecodeBase (const char *component_name)
| TrcPktDecodeBase (const char *component_name, int instIDNum)
virtual | ~TrcPktDecodeBase ()
virtual ocsd_datapath_resp_t | PacketDataIn (const ocsd_datapath_op_t op, const ocsd_trc_index_t index_sop, const EtmV3TrcPacket *p_packet_in)
ocsd_err_t | setProtocolConfig (const EtmV3Config *config)
const EtmV3Config * | getProtocolConfig () const
Public Member Functions inherited from TrcPktDecodeI
| TrcPktDecodeI (const char *component_name)
| TrcPktDecodeI (const char *component_name, int instIDNum)
virtual | ~TrcPktDecodeI ()
componentAttachPt< ITrcGenElemIn > * | getTraceElemOutAttachPt ()
componentAttachPt< ITargetMemAccess > * | getMemoryAccessAttachPt ()
componentAttachPt< IInstrDecode > * | getInstrDecodeAttachPt ()
void | setUsesMemAccess (bool bUsesMemaccess)
const bool | getUsesMemAccess () const
void | setUsesIDecode (bool bUsesIDecode)
const bool | getUsesIDecode () const
Public Member Functions inherited from TraceComponent
| TraceComponent (const std::string &name)
| TraceComponent (const std::string &name, int instIDNum)
virtual | ~TraceComponent ()
const std::string & | getComponentName () const
void | setComponentName (const std::string &name)
componentAttachPt< ITraceErrorLog > * | getErrorLogAttachPt ()
ocsd_err_t | setComponentOpMode (uint32_t op_flags)
const uint32_t | getComponentOpMode () const
const uint32_t | getSupportedOpModes () const
void | setAssocComponent (TraceComponent *assocComp)
TraceComponent * | getAssocComponent ()
void | LogDefMessage (const std::string &msg)
Public Member Functions inherited from IPktDataIn< P >
| IPktDataIn ()
virtual | ~IPktDataIn ()
Public Member Functions inherited from ITrcTypedBase
| ITrcTypedBase ()
virtual | ~ITrcTypedBase ()

## Protected Member Functions

virtual ocsd_datapath_resp_t | processPacket ()
virtual ocsd_datapath_resp_t | onEOT ()
virtual ocsd_datapath_resp_t | onReset ()
virtual ocsd_datapath_resp_t | onFlush ()
virtual ocsd_err_t | onProtocolConfig ()
virtual const uint8_t | getCoreSightTraceID ()
void | initDecoder ()
| initial state on creation (zeros all config) More...
void | resetDecoder ()
| reset state to start of decode. (moves state, retains config) More...
ocsd_datapath_resp_t | decodePacket (bool &pktDone)
| decode a packet More...
ocsd_datapath_resp_t | processISync (const bool withCC, const bool firstSync=false)
ocsd_datapath_resp_t | processBranchAddr ()
ocsd_datapath_resp_t | processPHdr ()
ocsd_datapath_resp_t | sendUnsyncPacket ()
| send an initial unsync packet when decoder starts More...
OcsdTraceElement * | GetNextOpElem (ocsd_datapath_resp_t &resp)
| get the next element from the element list. More...
Protected Member Functions inherited from TrcPktDecodeBase< EtmV3TrcPacket, EtmV3Config >
void | ClearConfigObj ()
Protected Member Functions inherited from TrcPktDecodeI
const bool | checkInit ()
virtual void | onFirstInitOK ()
ocsd_datapath_resp_t | outputTraceElement (const OcsdTraceElement &elem)
ocsd_datapath_resp_t | outputTraceElementIdx (ocsd_trc_index_t idx, const OcsdTraceElement &elem)
ocsd_err_t | accessMemory (const ocsd_vaddr_t address, const ocsd_mem_space_acc_t mem_space, uint32_t *num_bytes, uint8_t *p_buffer)
ocsd_err_t | instrDecode (ocsd_instr_info *instr_info)
Protected Member Functions inherited from TraceComponent
void | LogError (const ocsdError &Error)
void | LogMessage (const ocsd_err_severity_t filter_level, const std::string &msg)
const ocsd_err_severity_t | getErrorLogLevel () const
const bool | isLoggingErrorLevel (const ocsd_err_severity_t level) const
void | updateErrorLogLevel ()
void | do_attach_notify (const int num_attached)
void | Init (const std::string &name)

## Additional Inherited Members

Protected Attributes inherited from TrcPktDecodeBase< EtmV3TrcPacket, EtmV3Config >
EtmV3Config * | m_config
const EtmV3TrcPacket * | m_curr_packet_in
Protected Attributes inherited from TrcPktDecodeI
componentAttachPt< ITrcGenElemIn > | m_trace_elem_out
componentAttachPt< ITargetMemAccess > | m_mem_access
componentAttachPt< IInstrDecode > | m_instr_decode
ocsd_trc_index_t | m_index_curr_pkt
bool | m_decode_init_ok
| set true if all attachments in place for decode. (remove checks in main throughput paths) More...
bool | m_config_init_ok
| set true if config set. More...
std::string | init_err_msg
| error message for init error More...
bool | m_uses_memaccess
bool | m_uses_idecode
Protected Attributes inherited from TraceComponent
uint32_t | m_op_flags
| current component operational mode flags. More...
uint32_t | m_supported_op_flags
| supported component operational mode flags - derived class to intialise. More...

## Detailed Description

Definition at line 207 of file trc_pkt_decode_etmv3.h.

## Constructor & Destructor Documentation

## TrcPktDecodeEtmV3() [1/2]

TrcPktDecodeEtmV3::TrcPktDecodeEtmV3 | ( |  | ) |

## TrcPktDecodeEtmV3() [2/2]

TrcPktDecodeEtmV3::TrcPktDecodeEtmV3 | ( | int | instIDNum | ) |

## ~TrcPktDecodeEtmV3()

virtual TrcPktDecodeEtmV3::~TrcPktDecodeEtmV3 | ( |  | ) |

virtual

## Member Function Documentation

## decodePacket()

ocsd_datapath_resp_t TrcPktDecodeEtmV3::decodePacket | ( | bool & | pktDone | ) |

protected

decode a packet

## getCoreSightTraceID()

virtual const uint8_t TrcPktDecodeEtmV3::getCoreSightTraceID | ( |  | ) |

inline protected virtual

Implements TrcPktDecodeI.

Definition at line 221 of file trc_pkt_decode_etmv3.h.

## GetNextOpElem()

OcsdTraceElement* TrcPktDecodeEtmV3::GetNextOpElem | ( | ocsd_datapath_resp_t & | resp | ) |

protected

get the next element from the element list.

## initDecoder()

void TrcPktDecodeEtmV3::initDecoder | ( |  | ) |

protected

initial state on creation (zeros all config)

## onEOT()

virtual ocsd_datapath_resp_t TrcPktDecodeEtmV3::onEOT | ( |  | ) |

protected virtual

Implements TrcPktDecodeI.

## onFlush()

virtual ocsd_datapath_resp_t TrcPktDecodeEtmV3::onFlush | ( |  | ) |

protected virtual

Implements TrcPktDecodeI.

## onProtocolConfig()

virtual ocsd_err_t TrcPktDecodeEtmV3::onProtocolConfig | ( |  | ) |

protected virtual

Implements TrcPktDecodeI.

## onReset()

virtual ocsd_datapath_resp_t TrcPktDecodeEtmV3::onReset | ( |  | ) |

protected virtual

Implements TrcPktDecodeI.

## processBranchAddr()

ocsd_datapath_resp_t TrcPktDecodeEtmV3::processBranchAddr | ( |  | ) |

protected

## processISync()

ocsd_datapath_resp_t TrcPktDecodeEtmV3::processISync | ( | const bool | withCC,
|  | const bool | firstSync = `false`
| ) |  |

protected

## processPacket()

virtual ocsd_datapath_resp_t TrcPktDecodeEtmV3::processPacket | ( |  | ) |

protected virtual

Implements TrcPktDecodeI.

## processPHdr()

ocsd_datapath_resp_t TrcPktDecodeEtmV3::processPHdr | ( |  | ) |

protected

## resetDecoder()

void TrcPktDecodeEtmV3::resetDecoder | ( |  | ) |

protected

reset state to start of decode. (moves state, retains config)

## sendUnsyncPacket()

ocsd_datapath_resp_t TrcPktDecodeEtmV3::sendUnsyncPacket | ( |  | ) |

protected

send an initial unsync packet when decoder starts

The documentation for this class was generated from the following file:

- /build/libopencsd-nipXOR/libopencsd-1.2.0/decoder/include/opencsd/etmv3/trc_pkt_decode_etmv3.h